diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/numeric.h ircd-hybrid-6.0/include/numeric.h
--- ircd-hybrid-6.0.orig/include/numeric.h	Fri May 11 19:58:35 2001
+++ ircd-hybrid-6.0/include/numeric.h	Fri May 11 15:12:38 2001
@@ -320,6 +320,7 @@
 #define ERR_NICKNAMEINUSE    433
 #define ERR_NICKCOLLISION    436
 #define ERR_UNAVAILRESOURCE  437
+#define ERR_BANNICKCHANGE    438
 
 #define ERR_USERNOTINCHANNEL 441
 #define ERR_NOTONCHANNEL     442
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/messages.tab ircd-hybrid-6.0/src/messages.tab
--- ircd-hybrid-6.0.orig/src/messages.tab	Fri May 11 19:58:35 2001
+++ ircd-hybrid-6.0/src/messages.tab	Fri May 11 15:13:47 2001
@@ -479,7 +479,7 @@
 /* 435 */       (char *)NULL,
 /* 436 ERR_NICKCOLLISION, */    ":%s 436 %s %s :Nickname collision KILL",
 /* 437 ERR_NOTAVAILABLE, */     ":%s 437 %s %s :Nick/channel is temporarily unavailable",
-/* 438 */       (char *)NULL,
+/* 438 ERR_BANNICKCHANGE */     ":%s 438 %s %s :The hand of the deity is upon you, thy nick may not change",
 /* 439 */       (char *)NULL,
 /* 440 */       (char *)NULL,
 /* 441 ERR_USERNOTINCHANNEL, */ ":%s 441 %s %s %s :They aren't on that channel",
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/messages_cust.tab ircd-hybrid-6.0/src/messages_cust.tab
--- ircd-hybrid-6.0.orig/src/messages_cust.tab	Fri May 11 19:58:35 2001
+++ ircd-hybrid-6.0/src/messages_cust.tab	Fri May 11 19:27:26 2001
@@ -479,8 +479,8 @@
 /* 434 */       (char *)NULL,
 /* 435 */       (char *)NULL,
 /* 436 ERR_NICKCOLLISION, */    ":%s 436 %s %s :Nickname collision KILL",
 /* 437 ERR_NOTAVAILABLE, */     ":%s 437 %s %s :Nick/channel is temporarily unavailable",
-/* 438 */       (char *)NULL,
+/* 438 ERR_BANNICKCHANGE */     ":%s 438 %s %s :The hand of the deity is upon you, thy nick may not change",
 /* 439 */       (char *)NULL,
 /* 440 */       (char *)NULL,
 /* 441 ERR_USERNOTINCHANNEL, */ ":%s 441 %s %s %s :They aren't on that channel",
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Fri May 11 19:58:34 2001
+++ ircd-hybrid-6.0/src/s_user.c	Fri May 11 19:53:37 2001
@@ -1207,6 +1207,7 @@
 static int nickkilldone(aClient *cptr, aClient *sptr, int parc,
                  char *parv[], time_t newts,char *nick)
 {
+  Link* channels;
   int setflags = sptr->umodes;
 
   if (IsServer(sptr))
@@ -1266,7 +1267,20 @@
         sptr->tsinfo = newts ? newts : CurrentTime;
 
       if(MyConnect(sptr) && IsRegisteredUser(sptr))
-        {     
+        { 
+	  for (channels = sptr->user->channel; channels; channels = channels->next)
+	    {
+	      if (can_send(sptr, channels->value.chptr) != 0)
+		{
+		  /* Cannot send to that channel, so cannot change nicks */
+		  sendto_one(sptr, form_str(ERR_BANNICKCHANGE),
+			     me.name,
+			     sptr->name,
+			     nick);
+		  return 0;
+		}
+	    }
+
 #ifdef ANTI_NICK_FLOOD
 
           if( (sptr->last_nick_change + MAX_NICK_TIME) < CurrentTime)
